#region "Usings"

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.IO;

#endregion

/// <summary>
/// Application methods
/// </summary>

public class Global : System.Web.HttpApplication
{
    public static string kenticoDomain = "http://static.localhost";
    public static int clientCacheMinutes = 60;

    public void Application_BeginRequest(object sender, EventArgs e)
    {
        string fileUrl = kenticoDomain + Request.Url.AbsolutePath;
        
        if (HttpContext.Current.Cache[Request.Url.AbsolutePath] == null)
        {
            // Creates an HttpWebRequest for the specified URL. 
            HttpWebRequest myHttpWebRequest = (HttpWebRequest)WebRequest.Create(fileUrl);

            try
            {
                // Sends the HttpWebRequest and waits for response.
                HttpWebResponse myHttpWebResponse = (HttpWebResponse)myHttpWebRequest.GetResponse();
                
                using(BinaryReader reader = new BinaryReader(myHttpWebResponse.GetResponseStream()))
                {
                    HttpContext.Current.Cache[Request.Url.AbsolutePath] = HelperClass.ReadAllBytes(reader);
                    HttpContext.Current.Cache[Request.Url.AbsolutePath + "_mimetype"] = myHttpWebResponse.ContentType;
                }

                // close the response
                myHttpWebResponse.Close();

            }
            catch { }
         }


        // Response
        Response.Clear();
        // Clear cookies
        Response.Cookies.Clear();
        // No revalidation
        Response.Cache.SetRevalidation(HttpCacheRevalidation.None);
        // Setup the client cache
        Response.Cache.SetCacheability(HttpCacheability.Public);
        // Set expires headers
        Response.Cache.SetExpires(DateTime.Now.AddMinutes(clientCacheMinutes));

        // Set Content type
        Response.ContentType = (string)HttpContext.Current.Cache[Request.Url.AbsolutePath + "_mimetype"];

        try
        {
            // Write data to response
            Response.BinaryWrite((byte[])HttpContext.Current.Cache[Request.Url.AbsolutePath]);
        }
        catch { }

        Response.Flush();
        Response.Close();
        Response.End();
   }
}

